package org.jeecg.modules.stm.wb.manage.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.wb.manage.entity.WbPullDataLog;
import org.jeecg.modules.stm.wb.manage.service.IWbPullDataLogService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 抓取数据日志
 * @Author: jeecg-boot
 * @Date:   2024-06-01
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/wb.manage/wbPullDataLog")
@Slf4j
public class WbPullDataLogController extends JeecgController<WbPullDataLog, IWbPullDataLogService> {
	@Autowired
	private IWbPullDataLogService wbPullDataLogService;
	
	/**
	 * 分页列表查询
	 *
	 * @param wbPullDataLog
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "抓取数据日志-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<WbPullDataLog>> queryPageList(WbPullDataLog wbPullDataLog,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<WbPullDataLog> queryWrapper = QueryGenerator.initQueryWrapper(wbPullDataLog, req.getParameterMap());
		Page<WbPullDataLog> page = new Page<WbPullDataLog>(pageNo, pageSize);
		IPage<WbPullDataLog> pageList = wbPullDataLogService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param wbPullDataLog
	 * @return
	 */
	@AutoLog(value = "抓取数据日志-添加")
	  
	@RequiresPermissions("wb.manage:wb_pull_data_log:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody WbPullDataLog wbPullDataLog) {
		wbPullDataLogService.save(wbPullDataLog);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param wbPullDataLog
	 * @return
	 */
	@AutoLog(value = "抓取数据日志-编辑")
	  
	@RequiresPermissions("wb.manage:wb_pull_data_log:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody WbPullDataLog wbPullDataLog) {
		wbPullDataLogService.updateById(wbPullDataLog);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "抓取数据日志-通过id删除")
	  
	@RequiresPermissions("wb.manage:wb_pull_data_log:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		wbPullDataLogService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "抓取数据日志-批量删除")
	  
	@RequiresPermissions("wb.manage:wb_pull_data_log:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.wbPullDataLogService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "抓取数据日志-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<WbPullDataLog> queryById(@RequestParam(name="id",required=true) String id) {
		WbPullDataLog wbPullDataLog = wbPullDataLogService.getById(id);
		if(wbPullDataLog==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(wbPullDataLog);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param wbPullDataLog
    */
    @RequiresPermissions("wb.manage:wb_pull_data_log:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, WbPullDataLog wbPullDataLog) {
        return super.exportXls(request, wbPullDataLog, WbPullDataLog.class, "抓取数据日志");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("wb.manage:wb_pull_data_log:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, WbPullDataLog.class);
    }

}
